;Vertex shading engine
;by Ky3R [kuzmacrt(at)mail(dot)ru] +38-095-689-77-07
;made in november 2009 or something =)
;use as you please!)
Type model
Field mesh
Field shader
End Type

Function NewShadingModel(msh,x,y,z)
mdl.model=New model
mdl\shader=CopyEntity(msh)
EntityFX mdl\shader,2
color_mesh(mdl\shader,0,0,0)
EntityAlpha mdl\shader,0.5
EntityPickMode mdl\shader,2,1
PositionEntity mdl\shader,x,y,z
EntityParent mdl\shader,msh
End Function

Function ClearShadingModels()
For mdl.model=Each model	
	FreeEntity mdl\shader
	Delete mdl.model
Next	
End Function



Function ShadeModels(pivot,maincam,r,g,b)
Local cam=CreateCamera()
shdd=0
PositionEntity cam,EntityX(pivot),EntityY(pivot),EntityZ(pivot)
RotateEntity cam,EntityPitch(pivot),EntityYaw(pivot),EntityRoll(pivot)

CameraViewport maincam,0,0,1,1
CameraViewport cam,-GraphicsWidth(),-GraphicsHeight(),GraphicsWidth(),GraphicsHeight()

For mdl.model=Each model
	For s=1 To CountSurfaces(mdl\shader)
		surf=GetSurface(mdl\shader,s)
		For a=0 To CountVertices(surf)-1
			CameraProject cam,VertexX(surf,a),VertexY(surf,a),VertexZ(surf,a)
			px=ProjectedX()
			py=ProjectedY()
			
			ent=CameraPick(cam,px,py)
			
				If ent>0 Then
					If mdl\shader=ent Then
						srf=PickedSurface()
						trn=PickedTriangle()
						
						For i=0 To 2
							v=TriangleVertex(srf,trn,i)
							If VertexX(srf,v)=VertexX(surf,a) And VertexY(srf,v)=VertexY(surf,a) And VertexZ(srf,v)=VertexZ(surf,a) Then
								VertexColor srf,v,r,g,b
								shdd=shdd+1
							End If
						Next
						
					End If
				End If
		Next
	Next
Next
CameraViewport cam,0,0,1,1
CameraViewport maincam,0,0,GraphicsWidth(),GraphicsHeight()
FreeEntity cam
Return shdd
End Function

Function Color_Mesh(mesh,r,g,b)
	For s=1 To CountSurfaces(mesh)
		surf=GetSurface(mesh,s)
		For a=0 To CountVertices(surf)-1
			VertexColor surf,a,r,g,b
		Next
	Next
End Function

Function HowManyVertex(mesh)
vx=0
For s=1 To CountSurfaces(mesh)
	surf=GetSurface(mesh,s)
	For a=0 To CountVertices(surf)-1
		vx=vx+1
	Next
Next
Return vx
End Function