;Simple example of using my functions =)
;by me =)
Include "shadows.bb"
Graphics3D 1280,1024,32,1
SetBuffer BackBuffer()

Global target=CreateMesh()

Global camera=CreateCamera(target)

Global logo=LoadSprite("media\logo.bmp",4,camera)
	EntityOrder logo,-2
	PositionEntity logo,0,0.5,1.1
	ScaleSprite logo,0.32,0.12
Global logo_sh=LoadSprite("media\logo.bmp",4,camera)
	EntityOrder logo,-1
	PositionEntity logo_sh,0,0.5,1.1
	ScaleSprite logo_sh,0.34,0.14
	EntityColor logo_sh,32,32,32
	EntityAlpha logo_sh,0.25

PositionEntity camera,-150,45,-125
RotateEntity camera,15,-60,0
CameraClsColor camera,32,64,64

Global dspr = CreateMesh(camera)
Global suf = CreateSurface(dspr)
AddVertex suf, -1, 1, 0, 0, 0
AddVertex suf, 1, 1, 0, 1, 0
AddVertex suf, -1, -1, 0, 0, 1
AddVertex suf, 1, -1, 0, 1, 1
AddTriangle suf, 0, 1, 2
AddTriangle suf, 3, 2, 1
ScaleEntity dspr, 2048.0 / Float(GraphicsWidth()), 2048.0 / Float(GraphicsHeight()), 1
PositionEntity dspr, 0, 0, 1.0001
EntityOrder dspr, -100
EntityColor dspr,0,0,0
EntityAlpha dspr,0
Global d_alpha=99

Global scenery=LoadMesh("media\star.3ds")
NewShadingModel(scenery,0,0,0);here we add a model that will be shaded

Global sky=CreateSphere(32)
ScaleEntity sky,500,500,500
EntityOrder sky,99999
FlipMesh sky
sky_tex=LoadTexture("media\hawai.jpg")
EntityTexture sky,sky_tex
EntityFX sky,1

Text GraphicsWidth()/2-StringWidth("Generating light maps...")/2,GraphicsHeight()/2-StringHeight("A")/2,"Generating light maps..."
Flip
ShadeModels(camera,camera,255,100,0);there we shade all our meshes we added before)))

PositionEntity camera,100,20,5
RotateEntity camera,9,100,0
Cls

While cont=0
	Cls
	If esc=0 Then shadedisplay(0) Else shadedisplay(100)
	If KeyHit(1) Then esc=1
	If d_alpha=100 Then cont=1
	TurnEntity target,0,0.1,0
	PositionEntity sky,EntityX(camera),EntityY(camera),EntityZ(camera)
	RenderWorld
	Flip
Wend
End

Function ShadeDisplay(alpha)
	If d_alpha>alpha Then d_alpha=d_alpha-1
	If d_alpha<alpha Then d_alpha=d_alpha+1
	EntityAlpha dspr,d_alpha*0.01
End Function